<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body"   id="dataTableBox">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="bigdataModuleLink" name="bigdataModuleLink" lay-search>
                                <option value="">联动支持</option>
                                <option value="0"  >不支持</option>
                                <option value="mapLink"  >此模块为地图联动源</option>
                                <option value="dateLink"  >此模块为时间联动源</option>
                                <option value="selectLink"  >此模块为选项联动源</option>
                            </select>
                        </div>
                        <div class="layui-inline layui-form search-item" id="bigdataModuleTypeBox" lay-filter="bigdataModuleTypeBox"></div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="mapEvent">
                                <i class="fa fa-lg fa-map"></i> 地图区域工具
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script id="bigdataModuleTypeTemplate" type="text/html">
    <select id="bigdataModuleType" name="bigdataModuleType">
        <option value="">模块类型</option>
        {{# for(var i = 0, item; item = d[i++];) { }}
        <option value="{{item.dataId}}">{{item.dataName}}</option>
        {{# } }}
    </select>
</script>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'laytpl', 'common', 'form'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var laytpl = layui.laytpl;
        var form = layui.form;
        var common = layui.common;
        var resizeTimeout = null;
        var tableUrl = 'api/bigdatamodule/listpagebigdatamodule';
        var viewer = new Viewer(document.getElementById("dataTableBox"), {navbar: false});

        var initImageTimeout;
        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'bigdataModulePhoto', width: 250, title: '模块预览', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                var img = '<img id="' + rowData + '" src="route/file/download/false/' + rowData  + '" align="加载失败" lay-event="bigdataModulePhotoImageEvent">';
                                if(initImageTimeout) {
                                    clearTimeout(initImageTimeout);
                                }
                                initImageTimeout = setTimeout(function() {
                                    viewer.update();
                                }, 500);
                                return img;
                            }
                        },{field: 'bigdataModuleCode', width: 250, title: '模块编码', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'bigdataModuleName', width: 250, title: '模块名称', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'bigdataModuleTypeDictionaryName', width: 200, title: '模块类型', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'bigdataModuleSwitch', width: 150, fixed: 'right', title: '模块发布', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                return '<input  type="checkbox" value="' + rowData + '"  '+ ( rowData == 1 ? "checked" : "") + '  bigdataModuleId="'+ row.bigdataModuleId +'" lay-filter="bigdataModuleSwitchEvent"  name="bigdataModuleSwitch" lay-skin="switch" lay-text="开启|关闭">';
                            }
                        },
                        {field:'templateContentButton',fixed: 'right', width:150, title: '模块代码', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                return '<a href="javascript:void(0);" class="layui-btn layui-btn-xs layui-btn-radius"  lay-event="moduleContentEvent">编辑模块代码</a>';
                            }
                        }
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }

        // 初始化模块类型下拉选择
        function initBigdataModuleTypeSelect() {
            top.restAjax.get(top.restAjax.path('api/data/listbyparentid/e5078e2b-fa0e-41c8-9b3a-9dcec1ff8855', []), {}, null, function(code, data, args) {
                laytpl(document.getElementById('bigdataModuleTypeTemplate').innerHTML).render(data, function(html) {
                    document.getElementById('bigdataModuleTypeBox').innerHTML = html;
                });
                form.render('select', 'bigdataModuleTypeBox');
            }, function(code, data) {
                top.dialog.msg(data.msg);
            });
        }

        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val(),
                    bigdataModuleLink:  $('#bigdataModuleLink').val(),
                    bigdataModuleType: $('#bigdataModuleType').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
            initBigdataModuleTypeSelect();
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/bigdatamodule/removebigdatamodule/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });

        // 显示开关
        form.on('switch(bigdataModuleSwitchEvent)', function () {
            var loadLayerIndex;
            var obj = {};
            top.restAjax.put(top.restAjax.path('api/bigdatamodule/updatebigdatamoduleswitch/{bigdataModuleId}/{bigdataModuleSwitch}', [$(this).attr("bigdataModuleId"), this.checked]), obj, null, function(code, data) {
            }, function(code, data) {
                top.dialog.msg(data.msg);
            }, function() {
                loadLayerIndex = top.dialog.msg(top.dataMessage.committing, {icon: 16, time: 0, shade: 0.3});
            }, function() {
                top.dialog.close(loadLayerIndex);
            });
        });

        // 表格行中按钮事件
        table.on('tool(dataTable)', function(obj) {
            var layEvent = obj.event;
            var data = obj.data;
            if(layEvent === 'moduleContentEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/bigdatamodule/updatebigdatamodulecontent?bigdataModuleId={bigdataModuleId}', [data.bigdataModuleId]),
                    title: data.bigdataModuleName,
                    width: '100%',
                    height: '100%',
                    onClose: function() {
                        reloadTable();
                    }
                });
            }
        });


        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'mapEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/bigdatamodule/bigdatamodulemap', []),
                    end: function() {
                        reloadTable();
                    }
                });
            }else if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/bigdatamodule/savebigdatamodule', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/bigdatamodule/updatebigdatamodule?bigdataModuleId={bigdataModuleId}', [checkDatas[0].bigdataModuleId]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item['bigdataModuleId'];
                    }
                    removeData(ids);
                }
            }
        });
    });
</script>
</body>
</html>